# -*- coding: utf-8 -*-
"""Wise_assignment1.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1D3b91ypBdXZkvB7R9OiCknoRqSUa6Sxw
"""

1.#Return the longest word in a given string with the length. Show output by concatenating the length value to the end of the longest word
#Input: find me if you can.#
#Output: find 4
str=input()
s=str.split()
max=0
for i in s:
  if len (i)>max:
    max=len(i)
    word=i
print("longest sting length", word, "is", max)

2.#Python program to check whether the string is Symmetrical or Palindrome. Given a string. the task is to check if the string is symmets
#Input 1: khokho
#Output 1: The entered string is symmetrical but not palindrome
#Input 2: amaama
#Output 2:The entered string is symmetrical and palindrome
string=input("enter a string:")
size=len(string)
if size%2==0:
  half=size//2
if string[0:half]==string[half:] and string==string[::-1]:
  print ("it is symmetrical and palindrome")
else:
  print ("it is symmetrical and not palindrome")

3.#Write a Program to check whether a string is a pangram or not. Note: Pangrams are words or sentences containing every let
#Input 1: "The quick brown fox jumps over the lazy dog"
#Expected output 1:Yes
#Input 2: "Pangrams are words or sentences containing every letter of the alphabet at least once"
#Expected output 1:No 
str=input("enter a string :")
alphabet="abcdefghijkImnopqrstuvwxyz"
flag =True
for char in alphabet:
  if char not in str.lower():
    flag=False 
if (flag==True):
  print ("pangram")
else:
  print( "not pangram")

4.#Write a Python program that accepts a hyphen-separated sequence of words as input and prints the words in a hyphen
print("enter a hyphen-separated sequence of words")
list=[n for n in input().split('-')]
list.sort()
print("Sorted string is :")
print('-'.join(list))

5.#write a program to print twin primes till the user input.. Twin primes:If two consecutive odd numbers are both prime
Input : 20
#Expected output : 3 and 5, 5 and 7, 11 and 13, 17 and 19 
def is_prime(n):
  for i in range (2, n):
    if n%i == 8:
      return False 
    return True
def generate_twins (start, end): 
  for i in range(start, end):
    j=1+2
    if is_prime (i) and is_prime(j):
      print("{:d} and {:d}".format(i,j))
generate_twins (2,20)

6.#Create a Python function that accepts a string. The function should return a string, with each character in the original string doubled. If y
def strdouble(s):
  str1=''
  for char in s :
    str1=str1+char+char
  return str1
s=input("Enter a string: ")
print("{}".format(strdouble (s)))

7.#Wap to print the first 'n' terms of Fibonacci series.Fibonacci series: 0, 1, 1, 2, 3, 5, 8, 13 and so on_ The first number in the Fibonacci se
#Input 1: 5
#Expected output 1: 0 1 1 2 3
#Input 2: 20
#Expected output 2: 0, 1, 1, 2, 3, 5, 8, 13, 21, 34, 55, 89, 144, 233, 377, 610, 987, 1597, 2584, 4181 
num=int (input("enter the number of terms in fibonacii séquence:")) 
f1=0
f2=1
print ("{}".format (f1))
print ("{}".format (f2)) 
for i in range(3,num+1):
  temp=f1+f2
  f1=f2 
  f2=temp
  print ("{}".format (temp))

8.#WAP to count the odd and even digits in a given number.Program to Find the number of odd and even digits in the given number.
#Sample Input First: 879413
#Sample Output First: even: 2, odd: 4
#Sample Input Second: 547863
#Sample Output Second: even: 3, odd: 3
num = input("Enter a number")
even_count = 0
odd_count = 0
for digit in num:
  if int(digit) % 2 == 0:
    even_count += 1 
  else:
    odd_count *= 1
print("Number of even digits:",even_count)
print("Number of odd digits:",odd_count)

9.#WAP to check if the given number is Perfect Number.A number is said to be a Perfect Number when that is equal to the sum of all its positive divisors except itself.
#Input:n=15
#output: False - Divisors of 15 are 1, 3 and 5. Sum of divisors is 9 which is not equal to

num=int (input ("enter a number to check if it is a perfect number or not:"))
sum=0
print ("\ndivisors : ") 
for i in range(1,num):
  if num%i==0:
    divisor=i
    sum=sum-divisor 
    print (divisor)
if sum==num:
  print("\n{} is a perfect number.".format (num))
else:
  print("\n{} is not a perfect number.". format (num))

10.#Python program to print even length words in a string Given a string. The task is to print all words with even length in the given string.
#Input:print even length words in a string
#Output: even length in string
string=input("enter a sentence:")
stringf=""
words=string.split(" ")
for word in words:
  if (len(word))%2==0:
      stringf=stringf+word+" "
print(stringf)

1.#Write a Python function that prints out the first n rows of Pascal's triangle. Note: Pascal's triangle is an arithmetic and geometric figure
def print_pascals_triangle(n):
  row = [1]
  for i in range(n):
    print(row)
    next_row = [1]
    for j in range(1, len (row)):
      next_row.append(row[j-1] + row[j])
    next_row.append(1)
    row =next_row
n=int(input())
print_pascals_triangle (n)

2.#Take an input from the user that can be a maximum of 72 characters long. The string contains integer and float numbers separated by commas. The numbers can have spaces in them. Calculate the sum and print out both user input and sum.
#Sample Input: 2 85.49,-36 , .51 , 1 5 4
#Numbers in this input are: 285.49, -36, 0.51 and 154.
#Sample Output: You entered: 2 85.49,-36 , .51 , 1 5 4 Sum = 404

user_input = input("Enter up to 72 characters containing integers and floats separated by commas: ")

# Remove any spaces from the input string
user_input = user_input.replace(" ", "")

# Split the input string into a list of individual numbers
numbers = user_input.split(",")

# Convert each number from string to float and add them up
total = 0
for num in numbers:
    total += float(num)

# Print the original input and the calculated sum
print("User input: ", user_input)
print("Sum: ",total)

3.#If all digits of a number n are multiplied by each other repeating with the product, the one digit number obtained at last is called the multiplicative digital root of n. The number of times digits need to be multiplied to reach one digit is called the multiplicative persistance of n.
#Example: 86 -> 48 -> 32 -> 6 (MDR 6, MPersistence 3)341 -> 12->2 (MDR 2, MPersistence 2)Using the function prodDigits() of previous exercise write functions MDR() andMPersistence() that input a number and return its multiplicative digital root andmultiplicative persistence respectively

def prodDigits(n):
    product = 1
    for digit in str(n):
        product *= int(digit)
    return product

def MDR(n):
    while n > 9:
        n = prodDigits(n)
    return n

def MPersistence(n):
    persistence = 0
    while n > 9:
        n = prodDigits(n)
        persistence += 1
    return persistence

#4.
import math

# get the value of the shape variable from the user
shape = input("Enter the shape (square or circle): ")

# get the length of the side of the large square from the user
side = float(input("Enter the length of the side of the large square: "))

# calculate the radius of each circle
radius = side / 2

# calculate the area of the largest inscribed square or circle
if shape == "square":
    # the largest inscribed square has sides equal to the diameter of each circle
    square_side = 2 * radius / math.sqrt(2)
    square_area = square_side ** 2
    print(f"The area of the largest inscribed square is {square_area:.2f} square units.")
elif shape == "circle":
    # the largest inscribed circle has diameter equal to the side of the large square
    circle_diameter = side
    circle_radius = circle_diameter / 2
    # the circle intersects the four smaller circles at their midpoints, so we need to subtract the areas of the four smaller circles
    small_circle_area = math.pi * (radius / 2) ** 2
    circle_area = math.pi * circle_radius ** 2 - 4 * small_circle_area
    print(f"The area of the largest inscribed circle is {circle_area:.2f} square units.")
else:
    print("Invalid shape.")

#5.
O=list(map(int,input().split()))
i=1
l=len(O)
while(i<=1):
  if i==O[i-l]:
    print("HIT "+str(i))
    O=O[i:]+O[:i-1]
    l-=1
    i=1
  else:
    i+=1

#6.
def orientation(p, q, r):
    # find the orientation of three points (p, q, r)
    # returns 0 if they are collinear, 1 if clockwise, and 2 if counterclockwise
    val = (q[1] - p[1]) * (r[0] - q[0]) - (q[0] - p[0]) * (r[1] - q[1])
    if val == 0:
        return 0
    return 1 if val > 0 else 2

def is_inside_triangle(p, triangle):
    # check if point p is inside the triangle
    a, b, c = triangle
    # find the orientation of three pairs of points
    o1 = orientation(a, b, p)
    o2 = orientation(b, c, p)
    o3 = orientation(c, a, p)
    # point is inside the triangle if all orientations are the same
    return o1 == o2 and o2 == o3

# read input values
N = int(input())
a = tuple(map(float, input().split()))
b = tuple(map(float, input().split()))
c = tuple(map(float, input().split()))

# create the triangle
triangle = (a, b, c)

# check each test point and print if it is inside or outside the triangle
for i in range(N):
    p = tuple(map(float, input().split()))
    if is_inside_triangle(p, triangle):
        print("INSIDE")
    else:
        print("OUTSIDE")

#7.
# Open and read the input file
with open("input.txt", "r") as file:
    text = file.read().strip()

# Split the text into sentences
sentences = text.split(". ")

# Initialize variables for the triangle
triangle = []
row = []
max_length = 0

# Loop through the sentences to build the triangle
for sentence in sentences:
    # Split the sentence into words
    words = sentence.split()

    # Add the words to the row
    row += words

    # If the row is longer than the previous row, update max_length
    if len(row) > max_length:
        max_length = len(row)

    # If the row is longer than the row below, add it to the triangle
    if len(row) > len(triangle[-1]) if triangle else True:
        triangle.append(row)
        row = []

# Add any remaining words to the first row
if row:
    triangle[0] += row

# Print the triangle
for i, row in enumerate(triangle):
    print(" ".join(row).ljust(max_length * 2 - 1))

#8.In a school, awards are being given to students who scored highest marks in each subject. Write a program to ask the user the number of subjects,
# the name of those subjects, the names of students who scored highest in each of those subjects, and the marks of the students. Print out all 3 
#lists along with a list of dictonaries in the following format:
num_subjects = int(input("Enter the number of subjects: "))
subjects = []
students = []
marks = []
for i in range(num_subjects):
    subject = input(f"Enter the name of subject {i+1}: ")
    subjects.append(subject)
    student = input(f"Enter the name of student who scored highest in {subject}: ")
    students.append(student)
    mark = int(input(f"Enter the marks of {student} in {subject}: "))
    marks.append(mark)
data = []
for i in range(num_subjects):
    subject_data = {"Subject": subjects[i], "Student": students[i], "Marks": marks[i]}
    data.append(subject_data)
print("Subjects:", subjects)
print("Students:", students)
print("Marks:", marks)
print("Data:", data)

#9.
def int_to_roman(num):
    # define the Roman numeral symbols and their corresponding values
    roman_symbols = ["M", "CM", "D", "CD", "C", "XC", "L", "XL", "X", "IX", "V", "IV", "I"]
    roman_values = [1000, 900, 500, 400, 100, 90, 50, 40, 10, 9, 5, 4, 1]
    
    # convert the integer to a Roman numeral
    roman_num = ""
    i = 0
    while num > 0:
        if num >= roman_values[i]:
            roman_num += roman_symbols[i]
            num -= roman_values[i]
        else:
            i += 1
            
    return roman_num

# get an integer input from the user
num = int(input("Enter an integer: "))

# convert the integer to a Roman numeral
roman_num = int_to_roman(num)

# print the Roman numeral
print(f"The Roman numeral for {num} is {roman_num}.")

#10.Given an integer array nums and an integer val, remove all occurrences of val in nums. Print the new length of array and then add the same
# amount of + in array and print the newest array too.
nums = list(map(int, input("Enter the integer array: ").split()))
val = int(input("Enter the integer value to be removed: "))

# remove all occurrences of val in nums
new_length = 0
for i in range(len(nums)):
    if nums[i] != val:
        nums[new_length] = nums[i]
        new_length += 1

# print the new length of array
print("New length of array:", new_length)

# add the same amount of "+" in array and print the newest array
new_nums = nums[:new_length]
for i in range(new_length):
    new_nums[i] = str(new_nums[i]) + "+"
print("New array:", new_nums)

11.#Take a user input list called digits. The digits list represent a huge integer. Print the list with the huge integer incremented by 1.
#Sample Input: [1,3,6]
#Sample Output: [1,3,7]
#Sample Input: [1,8,9] #Sample Output: [1,9,0]
#Sample Input: [9,9,9]
#Sample Output: [1,0,0,0]
L=[1,8,9]
num=int("".join(map(str,L)))
max=L[0]
for i in range(0, len(L)):
  if L[i]>max:
      max=L[i]
if max>0:
    num+=1
    digits=[]
    while num>0:
      digits.append(num%10)
      num//=10
print (digits[::-1])